
blueblob = {}
blueblob.__index = blueblob

function blueblob:init()
	self.blueblobs = {}
	self.id = 9
	self.speed = 25
	self.jumpspeed = 120
	self.widthdif = 4
	self.heightdif = 4
	self.health = 4
	self.points = 100
	self.range = 3
	self.damage = 3
	self.type = "minion"
	self.img = love.graphics.newImage("res/blueblob.png")

	self.width = tilesize - self.widthdif
	self.height = tilesize - self.heightdif
	self.xoffset = self.widthdif/2
	self.yoffset = self.heightdif/2
	
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.blueblobs[i] = {}
		self.blueblobs[i].x = pos[i].x
		self.blueblobs[i].y = pos[i].y	
		self.blueblobs[i].hitbox = {x = self.blueblobs[i].x + self.xoffset, y = self.blueblobs[i].y + self.yoffset, width = self.width, height = self.height}
		self.blueblobs[i].velx = 0	
		self.blueblobs[i].vely = 0
		self.blueblobs[i].state = "run"
		self.blueblobs[i].fall = true
		self.blueblobs[i].move = false
		self.blueblobs[i].dir = "left"
		self.blueblobs[i].points = self.points
		self.blueblobs[i].health = self.health
		self.blueblobs[i].damage = self.damage
		self.blueblobs[i].onground = false
		self.blueblobs[i].hit = false
		self.blueblobs[i].anim = sprite:new(self.img, tilesize, tilesize, {{"stand",1}, {"run", 2},{"jump",1},{"hurt",1}},0,self.yoffset/2)
		self.blueblobs[i].active = false
		self.blueblobs[i].dead = false
		currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	setmetatable(blueblob, blueblob)
	enemy[#enemy + 1] = self.blueblobs --- remember this for future enemiessb
end

function blueblob:update(dt, i)

	self:move(dt, i)
	self:collision(i)

	if self.blueblobs[i].state == "hurt" then
		self.blueblobs[i].hit = false
	end

	if self.blueblobs[i].hit then
		self.blueblobs[i].state = "hurt"
		self.blueblobs[i].move = true
		self.blueblobs[i].onground = false
		self.blueblobs[i].vely = -self.jumpspeed/2
		if self.blueblobs[i].x > player.x then
			self.blueblobs[i].velx = self.speed
			self.blueblobs[i].dir = "left"
		else
			self.blueblobs[i].velx = -self.speed
			self.blueblobs[i].dir = "right"
		end
	end

	if self.blueblobs[i].onground then
		if getdist(self.blueblobs[i].x - self.width/2, self.blueblobs[i].y - self.height/2, player.x - player.width/2, player.y - player.height/2) < self.range * tilesize then
			self.blueblobs[i].move = true
			if player.x > self.blueblobs[i].x then -- player to the right
				self.blueblobs[i].onground = false
				self.blueblobs[i].velx = self.speed  * 2
				self.blueblobs[i].vely = -self.jumpspeed 
				self.blueblobs[i].dir = "right"
				self.blueblobs[i].state = "jump"
			else
				self.blueblobs[i].onground = false
				self.blueblobs[i].velx = -self.speed * 2
				self.blueblobs[i].vely = -self.jumpspeed
				self.blueblobs[i].dir = "left"
				self.blueblobs[i].state = "jump"

			end		
		end
	end

end

function blueblob:loop()
	local dt = love.timer.getDelta()
	for i = 1, #self.blueblobs do
		if self.blueblobs[i].active then
			self:update(dt, i)
			if gamedebug == true then
				love.graphics.setColor(255, 0, 0)
				love.graphics.rectangle("line", self.blueblobs[i].hitbox.x, self.blueblobs[i].hitbox.y, self.blueblobs[i].hitbox.width, self.blueblobs[i].hitbox.height)
				love.graphics.setColor(255,255,255)
			end
			self.blueblobs[i].anim:draw(self.blueblobs[i], 0.2)
			self.blueblobs[i].hit = false
		end
	end
end

function blueblob:move(dt, i)
	self.blueblobs[i].y = (self.blueblobs[i].y + self.blueblobs[i].vely * dt)
	self.blueblobs[i].x = (self.blueblobs[i].x + self.blueblobs[i].velx * dt)

	self.blueblobs[i].vely = self.blueblobs[i].vely + gravity * dt

	if self.blueblobs[i].onground and self.blueblobs[i].move then
		if self.blueblobs[i].dir == "left" then
			self.blueblobs[i].velx = self.blueblobs[i].velx + self.speed * dt
			if self.blueblobs[i].velx > -5 then
				self.blueblobs[i].velx = -self.speed *1.5
			end
		else
			self.blueblobs[i].velx = self.blueblobs[i].velx - self.speed  * dt
			if self.blueblobs[i].velx < 5 then
				self.blueblobs[i].velx = self.speed *1.5
			end
		end
	end

	if self.blueblobs[i].vely ~= 0 then
		self.blueblobs[i].fall = true
		self.blueblobs[i].onground = false
	else
		self.blueblobs[i].fall = false
	end
	

end

function blueblob:collision(i)
	self.blueblobs[i].hitbox = {x = self.blueblobs[i].x + self.xoffset, y = self.blueblobs[i].y + self.yoffset, width = self.width, height = self.height}
	local tile = map:getneartilepos(self.blueblobs[i].x, self.blueblobs[i].y, self.width, self.height, currentmap)	
	for y = 1, #tile do
		for k = 1, #solidids do
			if tile[y].id == solidids[k] then
				local col = getcollision(self.blueblobs[i].hitbox, tile[y], 3)
				if col then
					if col.hor then
						self.blueblobs[i].x = self.blueblobs[i].x + col.x 
						self.blueblobs[i].velx = 0
					end
					if col.ver then
						self.blueblobs[i].y = self.blueblobs[i].y + col.y
						self.blueblobs[i].vely = 0
						self.blueblobs[i].fall = false
					end
					if col.side == "right" then
						self.blueblobs[i].dir = "left"
					end
					if col.side == "left" then
						self.blueblobs[i].dir = "right" 
					end
					if col.side == "down" then
						if self.blueblobs[i].onground == false then
							self.blueblobs[i].velx = 0
						end
						self.blueblobs[i].onground = true
						self.blueblobs[i].state = "run"
					end
				self.blueblobs[i].hitbox = {x = self.blueblobs[i].x + self.xoffset, y = self.blueblobs[i].y + self.yoffset, width = self.width, height = self.height}
				end
			end
		end
	end
end

