
bossone = {}
bossone.__index = bossone

function bossone:init()
	self.bossones = {}
	self.id = 13
	self.speed = 80
	self.jumpspeed = 120
	self.widthdif = 7
	self.heightdif = 9
	self.health = 90
	self.maxhealth = self.health
	self.points = 100
	self.damage = 2
	self.type = "boss"
	self.gun = player.gun["bombgun"]
	self.img = love.graphics.newImage("res/gilda.png")

	self.width = 32 - self.widthdif
	self.height = 32 - self.heightdif
	self.xoffset = self.widthdif/2
	self.yoffset = self.heightdif/2
	
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.bossones[i] = {}
		self.bossones[i].x = pos[i].x
		self.bossones[i].y = pos[i].y	
		self.bossones[i].hitbox = {x = self.bossones[i].x + self.xoffset, y = self.bossones[i].y + self.yoffset, width = self.width, height = self.height}
		self.bossones[i].velx = 0	
		self.bossones[i].vely = 0
		self.bossones[i].state = "stand"
		self.bossones[i].fall = true
		self.bossones[i].dir = "left"
		self.bossones[i].points = self.points
		self.bossones[i].health = self.health
		self.bossones[i].maxhealth = self.maxhealth
		self.bossones[i].timer = timer:new(2, false)
		self.bossones[i].idle = true
		self.bossones[i].actionone = false
		self.bossones[i].actiontwo = false
		self.bossones[i].damage = self.damage
		self.bossones[i].onground = false
		self.bossones[i].hit = false
		self.bossones[i].anim = sprite:new(self.img, 32, 32, {{"stand",1}, {"run", 3},{"jump",1},{"confused",1}},0,self.yoffset)
		self.bossones[i].active = false
		self.bossones[i].dead = false	
		self.bossones[i].type = self.type
		self.bossones[i].gun = self.gun
		currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	setmetatable(bossone, bossone)
	enemy[#enemy + 1] = self.bossones --- remember this for future enemiessb
end

function bossone:update(dt, v)


	self:move(dt, v)
	self:collision(v, dt)

	if v.idle then
		v.timer.active = true
	else
		if v.timer.active then
			v.timer.active = false
			v.timer.time = 0
		
			local rand = math.random(1,2)

			if rand == 1 then
				-- first atack
				v.actionone = true
				v.state = "run"
				if player.x > v.x then
					v.velx = self.speed * 1.2
					v.dir = "right"		

				else
					v.velx = -self.speed * 1.2
					v.dir = "left"

				end
			elseif rand == 2 then
				-- second atack
				v.actiontwo = true
				v.state = "jump"
				if player.x > v.x then
					v.velx = self.speed
					v.vely = -self.jumpspeed 
					v.dir = "right"	

				else
					v.velx = -self.speed 
					v.vely = -self.jumpspeed
					v.dir = "left"

				end
			end
		
		end
	end
	
	if v.timer.tick then
		v.idle = false
	end



end

function bossone:loop()
	local dt = love.timer.getDelta()
	for i = 1, #self.bossones do
		if self.bossones[i].active then
			local v = self.bossones[i]
			self:update(dt, v)
			if gamedebug == true then
				love.graphics.setColor(255, 0, 0)
				love.graphics.rectangle("line", v.hitbox.x, v.hitbox.y, v.hitbox.width, v.hitbox.height)
				love.graphics.setColor(255,255,255)
			end
			v.anim:draw(v, 0.2)
			v.hit = false
		end
	end
end

function bossone:move(dt, v)
	v.y = (v.y + v.vely * dt)
	v.x = (v.x + v.velx * dt)

	v.vely = v.vely + gravity * dt

	if v.vely > 10 then
		v.fall = true
	else
		v.fall = false
	end
	
	if v.state ~= "confused" then

		if v.fall then
			--v.state = "jump"
		end
	end
	
end

function bossone:collision(v,dt)
	v.hitbox = {x = v.x + self.xoffset, y = v.y + self.yoffset, width = self.width, height = self.height}
	local tile = map:getneartilepos(v.x, v.y, self.width, self.height, currentmap)	
	for y = 1, #tile do
		for k = 1, #solidids do
			if tile[y].id == solidids[k] then
				local col = getcollision(v.hitbox, tile[y], 3)
				if col then
					if col.hor then
						v.x = v.x + col.x 
						v.velx = 0
						camera:shake(0.9, 1)
						if v.actionone then
							v.idle = true
							v.actionone = false
							v.vely = -self.jumpspeed
							v.state = "confused"
							v.y = v.y - gravity * dt
							if v.dir == "right" then
								v.velx = -self.speed/2
							else
								v.velx = self.speed/2
							end
								
						end
					end
					if col.ver then
						v.y = v.y + col.y
						v.vely = 0
						v.fall = false
						if v.actiontwo then
							v.idle = true
							v.velx = 0
							v.actiontwo = false
							camera:shake(0.9, 1)
							v.state = "stand"
						end
					end
					if col.side == "right" then
		

					end
					if col.side == "left" then


					end
					if col.side == "down" then
						if v.state == "confused" then
							v.velx = 0
						end
						v.onground = true
					end
					v.hitbox = {x = v.x + self.xoffset, y = v.y + self.yoffset, width = self.width, height = self.height}
				end
			end
		end
	end
end

