
bosstwo = {}
bosstwo.__index = bosstwo

function bosstwo:init()
	self.bosstwos = {}
	self.id = 14
	self.speed = 80
	self.jumpspeed = 120
	self.widthdif = 6
	self.heightdif = 5
	self.health = 100
	self.maxhealth = self.health
	self.points = 100
	self.damage = 2
	self.type = "boss"
	self.gun = player.gun["machine"]
	self.img = love.graphics.newImage("res/dragon.png")
	self.fireimg = love.graphics.newImage("res/fire.png")
	self.fire = {}
	self.fire.widthdif = 0
	self.fire.heightdif = 6
	self.fire.width = self.fireimg:getWidth()/2
	self.fire.height = self.fireimg:getHeight()

	self.fire[1] = love.graphics.newQuad(0,0,self.fire.width,self.fire.height, self.fireimg:getWidth(),self.fireimg:getHeight())
	self.fire[2] = love.graphics.newQuad(self.fire.width,0,self.fire.width,self.fire.height, self.fireimg:getWidth(),self.fireimg:getHeight())
	
	--REMEMBER: CHANGE FIRE WIDTH AND HEIGHT DIF
	self.width = 32 - self.widthdif
	self.height = 32 - self.heightdif
	self.xoffset = self.widthdif/2
	self.yoffset = self.heightdif/2
	
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.bosstwos[i] = {}
		self.bosstwos[i].x = pos[i].x
		self.bosstwos[i].y = pos[i].y	
		self.bosstwos[i].hitbox = {x = self.bosstwos[i].x + self.xoffset, y = self.bosstwos[i].y + self.yoffset, width = self.width, height = self.height}
		self.bosstwos[i].velx = 0	
		self.bosstwos[i].vely = 0
		self.bosstwos[i].state = "stand"
		self.bosstwos[i].fall = true
		self.bosstwos[i].dir = "left"
		self.bosstwos[i].points = self.points
		self.bosstwos[i].health = self.health
		self.bosstwos[i].maxhealth = self.maxhealth
		self.bosstwos[i].timer = timer:new(2,false)
		self.bosstwos[i].idle = true
		self.bosstwos[i].atack = false
		self.bosstwos[i].reachtop = false -- part of atack 1
		self.bosstwos[i].inity = 0
		self.bosstwos[i].gravity = gravity
		self.bosstwos[i].damage = self.damage
		self.bosstwos[i].onground = false
		self.bosstwos[i].hit = false
		self.bosstwos[i].anim = sprite:new(self.img, 32, 32, {{"stand",1}, {"run", 4},{"jump",4},{"fire",1}},0,self.yoffset)
		self.bosstwos[i].firetimer = timer:new(2, false) -- part of atack 2
		self.bosstwos[i].hitboxchange = false -- part of atack 2
		self.bosstwos[i].fireframe = 1 -- part of atack 2
		self.bosstwos[i].frametimer = timer:new(0.2,false) -- part of atack 2
		self.bosstwos[i].active = false
		self.bosstwos[i].dead = false	
		self.bosstwos[i].type = self.type
		self.bosstwos[i].gun = self.gun
		currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	setmetatable(bosstwo, bosstwo)
	enemy[#enemy + 1] = self.bosstwos --- remember this for future enemiessb
end

function bosstwo:update(dt, v)


	self:move(dt, v)
	self:collision(v)

	if v.timer.tick then
		v.idle = false
	end

	if v.idle then
		v.timer.active = true
		

	elseif v.idle == false and v.timer.active then
		v.timer.active = false
		
		v.atack = math.random(1,2)

		if v.atack == 1 then
			v.state = "jump"
			v.gravity = 0	
			v.vely = -self.jumpspeed/1.5
			v.inity = v.y
		
		elseif v.atack == 2 then
			v.state = "run"
			if player.x >= v.x then
				v.velx = self.speed/1.5
				v.dir = "right"

			else
				v.velx = -self.speed/1.5
				v.dir = "left"

			end
		
		end
		
	end

	if v.atack == 1 then
		if v.gravity == 0 and math.abs(player.x - v.x) > 10 then		
			if player.x >= v.x then
				v.velx = self.speed/1.5
				v.dir = "right"

			else
				v.velx = -self.speed/1.5
				v.dir = "left"


			end
		end

		if v.y < v.inity - tilesize*4.5 and v.reachtop == false then
			v.reachtop = true
			v.vely = 0
		end

		if v.vely == 0 then
			if math.abs(v.x - player.x) < 10 then
				v.velx = 0
				v.gravity = gravity
			end
		end

		if v.reachtop and v.y == v.inity then
			v.idle = true
			v.atack = false
			v.reachtop = false
			camera:shake(1,1)
			v.state = "stand"
		end
	elseif v.atack == 2 then

		if math.abs((player.x + player.width/2) - (v.x + self.width/2)) < self.fire.width*1.5 and v.firetimer.active == false then 
			v.firetimer.active = true
			v.state = "fire"
			v.velx = 0
			v.frametimer.active = true

		end

		if v.firetimer.tick then
			v.idle = true
			v.atack = false
			v.state = "stand"
			v.firetimer.active = false
			v.frametimer.active = false
			v.hitboxchange = false

		end
		
		if v.frametimer.tick then
			v.fireframe = v.fireframe + 1
			if v.fireframe >= 3 then
				v.fireframe = 1
			end
		end

		if v.firetimer.active then
			v.state = "fire"
			v.hitboxchange = not v.hitboxchange
		end
	
		--v.hitbox = {x = v.x + self.xoffset, y = v.y + self.yoffset, width = self.width, height = self.height}
		if v.hitboxchange then
			self.yoffset = self.height - 16 + self.heightdif/2
			self.xoffset = self.width + self.widthdif/2
			self.height = self.fire.height - self.fire.heightdif
			self.width = self.fire.width - self.fire.widthdif
			if v.dir == "left" then
				self.xoffset = -self.width + self.widthdif/2

			else
			

			end
		else
			self.width = 32 - self.widthdif
			self.height = 32 - self.heightdif
			self.xoffset = self.widthdif/2
			self.yoffset = self.heightdif/2	

		end

	end
end

function bosstwo:loop()
	local dt = love.timer.getDelta()
	for i = 1, #self.bosstwos do
		if self.bosstwos[i].active then
			local v = self.bosstwos[i]
			self:update(dt, v)
			if gamedebug == true then
				love.graphics.setColor(255, 0, 0)
				love.graphics.rectangle("line", v.hitbox.x, v.hitbox.y, v.hitbox.width, v.hitbox.height)
				love.graphics.setColor(255,255,255)
			end
			v.anim:draw(v, 0.2)
			if v.atack == 2 then
				if v.firetimer.active then
					local x = v.x
					local y = v.y + (32 - self.heightdif)/2 - self.fire.heightdif/2 + 2
					local scl = 1
					if v.dir == "right" then
						x = x + 32
					else
						scl = -1
						y = y + self.fire.height 
						
					end
					love.graphics.draw(self.fireimg, self.fire[v.fireframe],x,y,0,scl)
				end
			end
			v.hit = false
		end
	end
end

function bosstwo:move(dt, v)
	v.y = (v.y + v.vely * dt)
	v.x = (v.x + v.velx * dt)

	v.vely = v.vely + v.gravity * dt

	if v.vely > 10 then
		v.fall = true
	else
		v.fall = false
	end

	if v.fall then
		--v.state = "jump"
	end
end

function bosstwo:collision(v)
	v.hitbox = {x = v.x + self.xoffset, y = v.y + self.yoffset, width = self.width, height = self.height}
	local tile = map:getneartilepos(v.x, v.y, self.width, self.height, currentmap)	
	for y = 1, #tile do
		for k = 1, #solidids do
			if tile[y].id == solidids[k] then
				local col = getcollision(v.hitbox, tile[y], 3)
				if col then
					if col.hor then
						v.x = v.x + col.x 
						v.velx = 0
					end
					if col.ver then
						v.y = v.y + col.y
						v.vely = 0
						v.fall = false
					end
					if col.side == "right" then
		

					end
					if col.side == "left" then


					end
					if col.side == "down" then
						--v.state = "stand"
						v.onground = true
					end
					v.hitbox = {x = v.x + self.xoffset, y = v.y + self.yoffset, width = self.width, height = self.height}
				end
			end
		end
	end
end

