
bosstri = {}
bosstri.__index = bosstri

function bosstri:init()
	self.bosstris = {}
	self.id = 15
	self.speed = 80
	self.jumpspeed = 120
	self.widthdif = 15
	self.heightdif = 10
	self.health = 110
	self.maxhealth = self.health
	self.points = 100
	self.damage = 3
	self.type = "boss"

	local blankgun = {}
	local viewdata = love.image.newImageData(1,1)
	blankgun.view = love.graphics.newImage(viewdata)

	self.gun = blankgun
	self.img = love.graphics.newImage("res/crackle.png")

	self.width = 50 - self.widthdif
	self.height = 35 - self.heightdif
	self.xoffset = self.widthdif/2
	self.yoffset = self.heightdif/2

	self.rock = {}
	self.rock.img = love.graphics.newImage("res/rock.png")
	self.rock.width = self.rock.img:getWidth()
	self.rock.height = self.rock.img:getHeight()
	
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.bosstris[i] = {}
		self.bosstris[i].x = pos[i].x
		self.bosstris[i].y = pos[i].y	
		self.bosstris[i].hitbox = {x = self.bosstris[i].x + self.xoffset, y = self.bosstris[i].y + self.yoffset, width = self.width, height = self.height}
		self.bosstris[i].velx = 0	
		self.bosstris[i].vely = 0
		self.bosstris[i].state = "stand"
		self.bosstris[i].fall = true
		self.bosstris[i].dir = "left"
		self.bosstris[i].points = self.points
		self.bosstris[i].health = self.health
		self.bosstris[i].maxhealth = self.maxhealth
		self.bosstris[i].timer = timer:new(2,false)
		self.bosstris[i].idle = true
		self.bosstris[i].atack = false
		self.bosstris[i].rocks = {} -- atack 1
		self.bosstris[i].damage = self.damage
		self.bosstris[i].onground = false
		self.bosstris[i].hit = false
		self.bosstris[i].anim = sprite:new(self.img, 50, 35, {{"stand",1}, {"run", 2},{"jump",2},{"fire",1}},0,self.yoffset)
		self.bosstris[i].active = false
		self.bosstris[i].dead = false	
		self.bosstris[i].type = self.type
		self.bosstris[i].gun = self.gun
		self.bosstris[i].final = true
		currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	setmetatable(bosstri, bosstri)
	enemy[#enemy + 1] = self.bosstris --- remember this for future enemiessb
end

function bosstri:update(dt, v)


	self:move(dt, v)
	self:collision(v)

	if v.timer.tick then
		v.idle = false
	end

	if v.idle then
		v.timer.active = true

		
	elseif v.idle == false and v.timer.active then
		v.timer.active = false
		
		v.atack = 1--math.random(1,2)

		if v.atack == 1 then
			--trigger atack 1
			v.vely = -self.jumpspeed
			v.onground = false
			v.state = "jump"
			v.velx = 0
		
		elseif v.atack == 2 then
			--trigger atack 2
		
		end
		
	end

	if v.atack == 1 then
		-- atack 1
		if v.onground then
			camera:shake(1,1)	
			v.state = "stand"
			v.atack = false
			v.idle = true

			v.state = "run"

			local rand = math.random(1,2)
			if rand == 1 then
				v.dir = "right"
				v.velx = self.speed
			else
				v.dir = "left"
				v.velx = -self.speed
			end

			local xdif = 50
			local ydif = xdif * 2
			local middle = player.x + player.width/2 - self.rock.width/2
			for i = 1,5 do 

				local gravdif = 100
				local gravity = math.random(gravity - gravdif, gravity + gravdif)

				v.rocks[i] = {x = math.random(middle - xdif, middle + xdif), y = math.random(-camera.y - ydif - self.rock.height,-camera.y- self.rock.height), vely = 0, gravity = gravity}
			end
		end
			
			

	elseif v.atack == 2 then
		--atack 2

	end

	for i = 1, #v.rocks do

		v.rocks[i].y = (v.rocks[i].y + v.rocks[i].vely * dt)
		
		v.rocks[i].vely = v.rocks[i].vely + v.rocks[i].gravity * dt

		local hitbox = {x = v.rocks[i].x, y = v.rocks[i].y, width = self.rock.width, height = self.rock.height}
		
		
		if player.mercy == false then
			if shortaabb(hitbox, player.hitbox) then
				player.hp = player.hp - self.damage		
				player.mercy = true
				player.mercytimer.active = true
			end
		end
		
	end
end

function bosstri:loop()
	local dt = love.timer.getDelta()
	for i = 1, #self.bosstris do
		if self.bosstris[i].active then
			local v = self.bosstris[i]
			self:update(dt, v)
			if gamedebug == true then
				love.graphics.setColor(255, 0, 0)
				love.graphics.rectangle("line", v.hitbox.x, v.hitbox.y, v.hitbox.width, v.hitbox.height)
				love.graphics.setColor(255,255,255)
			end
			v.anim:draw(v, 0.2)
			
			for i = 1,#v.rocks do
				love.graphics.draw(self.rock.img,v.rocks[i].x, v.rocks[i].y)
			end
			
			v.hit = false
		end
	end
end

function bosstri:move(dt, v)
	v.y = (v.y + v.vely * dt)
	v.x = (v.x + v.velx * dt)

	v.vely = v.vely + gravity * dt

	if v.vely > 10 then
		v.fall = true
	else
		v.fall = false
	end

	if v.fall then
		--v.state = "jump"
	end
end

function bosstri:collision(v)
	v.hitbox = {x = v.x + self.xoffset, y = v.y + self.yoffset, width = self.width, height = self.height}
	local tile = map:getneartilepos(v.x, v.y, self.width, self.height, currentmap)	
	for y = 1, #tile do
		for k = 1, #solidids do
			if tile[y].id == solidids[k] then
				local col = getcollision(v.hitbox, tile[y], 3)
				if col then
					if col.hor then
						v.x = v.x + col.x 
						v.velx = 0
					end
					if col.ver then
						v.y = v.y + col.y
						v.vely = 0
						v.fall = false
					end
					if col.side == "right" then
						v.dir = "left"
						v.velx = -self.speed

					end
					if col.side == "left" then
						v.dir = "right"
						v.velx = self.speed

					end
					if col.side == "down" then
					--	v.state = "stand"
						v.onground = true
					end
					v.hitbox = {x = v.x + self.xoffset, y = v.y + self.yoffset, width = self.width, height = self.height}
				end
			end
		end
	end
end

