
fly = {}
fly.__index = fly

function fly:init()
	self.flys = {}
	self.id = 10
	self.speed = 100
	self.widthdif = 4
	self.heightdif = 10
	self.health = 3
	self.points = 100
	self.range = 5.6
	self.maxdist = 4
	self.damage = 1
	self.type = "minion"
	self.img = love.graphics.newImage("res/fly.png")

	self.width = tilesize - self.widthdif
	self.height = tilesize - self.heightdif
	self.xoffset = self.widthdif/2
	self.yoffset = self.heightdif/2
	
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.flys[i] = {}
		self.flys[i].x = pos[i].x
		self.flys[i].y = pos[i].y
		self.flys[i].width = self.width
		self.flys[i].height = self.height
		self.flys[i].hitbox = {x = self.flys[i].x + self.xoffset, y = self.flys[i].y + self.yoffset, width = self.width, height = self.height}
		self.flys[i].velx = 0	
		self.flys[i].vely = 0
		self.flys[i].state = "fly"
		self.flys[i].dir = "right"
		self.flys[i].canturn = true
		self.flys[i].points = self.points
		self.flys[i].health = self.health
		self.flys[i].damage = self.damage
		self.flys[i].hit = false
		self.flys[i].anim = sprite:new(self.img, tilesize, tilesize, {{"fly",2}, {"atack", 2},{"hurt",1}},0,self.yoffset/3)
		self.flys[i].active = false
		self.flys[i].dead = false
		self.flys[i].canatack = true
		self.flys[i].initx = self.flys[i].x
		self.flys[i].inity = self.flys[i].y
		self.flys[i].targety = 0
		self.flys[i].up = false
		currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	setmetatable(fly, fly)
	enemy[#enemy + 1] = self.flys --- remember this for future enemiessb
end

function fly:update(dt, i)

	self:move(dt, i)
	self:collision(i)

	if getdist(self.flys[i].x - self.width/2, self.flys[i].y - self.height/2, player.x - player.width/2, player.y - player.height/2) < self.range * tilesize then
		if self.flys[i].canatack then
			if self.flys[i].state ~= "atack" then
				if self.flys[i].x > player.x then
					self.flys[i].dir = "left"
					self.flys[i].state = "atack"
					self.flys[i].velx = -self.speed
					self.flys[i].vely = self.speed
					self.flys[i].atackdown = true
					self.flys[i].targety = player.y
				elseif self.flys[i].x < player.x then
					self.flys[i].dir = "right"
					self.flys[i].state = "atack"
					self.flys[i].velx = self.speed
					self.flys[i].vely = self.speed
					self.flys[i].atackdown = true
					self.flys[i].targety = player.y
				end
			end
		end
		self.flys[i].canatack = false
	else
		self.flys[i].canatack = true
	end
	
	if self.flys[i].state == "atack" then
		self.flys[i].vely = self.flys[i].vely - self.speed/2 * dt
		if self.flys[i].y > self.flys[i].targety then
			self.flys[i].vely = -self.speed
		end
	end
		
end

function fly:loop()
	local dt = love.timer.getDelta()
	for i = 1, #self.flys do
		if self.flys[i].active then
			self:update(dt, i)
			self.flys[i].hit = false
			if gamedebug == true then
				love.graphics.setColor(255, 0, 0)
				love.graphics.rectangle("line", self.flys[i].hitbox.x, self.flys[i].hitbox.y, self.flys[i].hitbox.width, self.flys[i].hitbox.height)
				love.graphics.setColor(255,255,255)
			end
			self.flys[i].anim:draw(self.flys[i], 0.2)
		end
	end
end

function fly:move(dt, i)
	self.flys[i].y = (self.flys[i].y + self.flys[i].vely * dt)
	self.flys[i].x = (self.flys[i].x + self.flys[i].velx * dt)

	local outrange = math.abs(self.flys[i].x - self.flys[i].initx) > (self.maxdist * tilesize)
	local ydist = 3
	if self.flys[i].state ~= "atack" then
		if self.flys[i].dir == "left" then
			if outrange and self.flys[i].canturn and self.flys[i].x < self.flys[i].initx then
				self.flys[i].velx = self.flys[i].velx + self.speed * dt
				if self.flys[i].velx > 0 then
					self.flys[i].dir = "right"
					self.flys[i].canturn = false
					self.flys[i].canatack = true
				end

			else
				self.flys[i].velx = self.flys[i].velx - self.speed * dt
				if self.flys[i].velx < -self.speed then
					self.flys[i].velx = -self.speed
					self.flys[i].canturn = true
				end
		
			end
		else
			if outrange and self.flys[i].canturn and self.flys[i].x > self.flys[i].initx then
				self.flys[i].velx = self.flys[i].velx - self.speed * dt
				if self.flys[i].velx < 0 then
					self.flys[i].dir = "left"
					self.flys[i].canturn = false
					self.flys[i].canatack = true				
				end
			else
				self.flys[i].velx = self.flys[i].velx + self.speed * dt
				if self.flys[i].velx > self.speed then
					self.flys[i].canturn = true
					self.flys[i].velx = self.speed
				end
			end
		end
		--- y
		local maxy = self.flys[i].inity + ydist
		local miny = self.flys[i].inity - ydist
		local speed = self.speed/10
		if self.flys[i].up then
			local diff = (miny-self.flys[i].y)/-ydist
			self.flys[i].vely = self.flys[i].vely - speed * diff * dt
			if self.flys[i].y <= miny then
				self.flys[i].up = false
				self.flys[i].vely = 0
			end


		else
			local diff = (maxy-self.flys[i].y)/ydist
			self.flys[i].vely = self.flys[i].vely + speed * diff * dt
			if self.flys[i].y >= maxy then
				self.flys[i].up = true
				self.flys[i].vely = 0
			end
		end
	end

	if self.flys[i].state ~= "fly" then
		if self.flys[i].y < self.flys[i].inity - ydist then
			self.flys[i].y = self.flys[i].inity	
			self.flys[i].vely = 0
			self.flys[i].state = "fly"
		end	
	end
end

function fly:collision(i)
	self.flys[i].hitbox = {x = self.flys[i].x + self.xoffset, y = self.flys[i].y + self.yoffset, width = self.width, height = self.height}
	local tile = map:getneartilepos(self.flys[i].x, self.flys[i].y, self.width, self.height, currentmap)	
	for y = 1, #tile do
		for k = 1, #solidids do
			if tile[y].id == solidids[k] then
				local col = getcollision(self.flys[i].hitbox, tile[y], 3)
				if col then
					if col.hor then
				
					end
					if col.ver then
			
					end
					if col.side == "right" then
			
					end
					if col.side == "left" then
				
					end
					if col.side == "down" then

					end
					self.flys[i].hitbox = {x = self.flys[i].x + self.xoffset, y = self.flys[i].y + self.yoffset, width = self.width, height = self.height}
				end
			end
		end
	end
end

