
redblob = {}
redblob.__index = redblob

function redblob:init()
	self.redblobs = {}
	self.id = 8
	self.speed = 25
	self.jumpspeed = 100
	self.widthdif = 4
	self.heightdif = 4
	self.health = 6
	self.points = 100
	self.range = 5
	self.damage = 1
	self.type = "minion"
	self.img = love.graphics.newImage("res/redblob.png")

	self.width = tilesize - self.widthdif
	self.height = tilesize - self.heightdif
	self.xoffset = self.widthdif/2
	self.yoffset = self.heightdif/2
	
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.redblobs[i] = {}
		self.redblobs[i].x = pos[i].x
		self.redblobs[i].y = pos[i].y
		self.redblobs[i].hitbox = {x = self.redblobs[i].x + self.xoffset, y = self.redblobs[i].y + self.yoffset, width = self.width, height = self.height}
		self.redblobs[i].velx = 0	
		self.redblobs[i].vely = 0
		self.redblobs[i].state = "run"
		self.redblobs[i].dir = "left"
		self.redblobs[i].points = self.points
		self.redblobs[i].health = self.health
		self.redblobs[i].damage = self.damage
		self.redblobs[i].onground = false
		self.redblobs[i].hit = false
		self.redblobs[i].anim = sprite:new(self.img, tilesize, tilesize, {{"stand",1}, {"run", 2},{"jump",1},{"hurt",1}}, 0, self.yoffset/2)
		self.redblobs[i].active = false
		self.redblobs[i].dead = false
		currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	setmetatable(redblob, redblob)
	enemy[#enemy + 1] = self.redblobs --- remember this for future enemiessb
end

function redblob:update(dt, i)

	self:move(dt, i)
	self:collision(i)
	
	--turning
	if self.redblobs[i].onground then
		if self.redblobs[i].dir == "right" then	
			local testx = self.redblobs[i].hitbox.x + self.redblobs[i].hitbox.width*(3/4)
			local testy = self.redblobs[i].hitbox.y + self.redblobs[i].hitbox.height + tilesize/2
			local testpoint = currentmap[math.floor(testy/16) + 1][math.floor(testx/16) + 1]

			if testpoint == 0 then
				self.redblobs[i].dir = "left"
			end
		elseif self.redblobs[i].dir == "left" then	
			local testx = self.redblobs[i].hitbox.x + self.redblobs[i].hitbox.width/4
			local testy = self.redblobs[i].hitbox.y + self.redblobs[i].hitbox.height + tilesize/2
			local testpoint = currentmap[math.floor(testy/16) + 1][math.floor(testx/16) + 1]

			if testpoint == 0 then
				self.redblobs[i].dir = "right"
			end
		end
	end

	if self.redblobs[i].state == "hurt" then
		self.redblobs[i].hit = false
	end

	if self.redblobs[i].hit then
		self.redblobs[i].state = "hurt"
		self.redblobs[i].onground = false
		self.redblobs[i].vely = -self.jumpspeed/2
		if self.redblobs[i].x > player.x then
			self.redblobs[i].velx = self.speed
			self.redblobs[i].dir = "left"
		else
			self.redblobs[i].velx = -self.speed
			self.redblobs[i].dir = "right"
		end
	end

	if self.redblobs[i].onground then
		if getdist(self.redblobs[i].x - self.width/2, self.redblobs[i].y - self.height/2, player.x - player.width/2, player.y - player.height/2) < self.range * tilesize then
			if player.x > self.redblobs[i].x then -- player to the right
				self.redblobs[i].onground = false
				self.redblobs[i].velx = self.speed * 2
				self.redblobs[i].vely = -self.jumpspeed 
				self.redblobs[i].dir = "right"
				self.redblobs[i].state = "jump"
			else
				self.redblobs[i].onground = false
				self.redblobs[i].velx = -self.speed * 2
				self.redblobs[i].vely = -self.jumpspeed	
				self.redblobs[i].dir = "left"
				self.redblobs[i].state = "jump"
	
			end
		end
	end

end

function redblob:loop()
	local dt = love.timer.getDelta()
	for i = 1, #self.redblobs do
		if self.redblobs[i].active then
			self:update(dt, i)
			self.redblobs[i].hit = false
			if gamedebug == true then
				love.graphics.setColor(255, 0, 0)
				love.graphics.rectangle("line", self.redblobs[i].hitbox.x, self.redblobs[i].hitbox.y, self.redblobs[i].hitbox.width, self.redblobs[i].hitbox.height)
				love.graphics.setColor(255,255,255)
			end
			self.redblobs[i].anim:draw(self.redblobs[i], 0.2)
		end
	end
end

function redblob:move(dt, i)
	self.redblobs[i].y = (self.redblobs[i].y + self.redblobs[i].vely * dt)
	self.redblobs[i].x = (self.redblobs[i].x + self.redblobs[i].velx * dt)

	self.redblobs[i].vely = self.redblobs[i].vely + gravity * dt

	if self.redblobs[i].onground then
		if self.redblobs[i].dir == "left" then
			self.redblobs[i].velx = self.redblobs[i].velx + self.speed * dt
			if self.redblobs[i].velx > -5 then
				self.redblobs[i].velx = -self.speed *1.5
			end
		else
			self.redblobs[i].velx = self.redblobs[i].velx - self.speed  * dt
			if self.redblobs[i].velx < 5 then
				self.redblobs[i].velx = self.speed *1.5
			end
		end
	end

	if self.redblobs[i].vely <= 0 then
		self.redblobs[i].onground = false
	end
end

function redblob:collision(i)
	self.redblobs[i].hitbox = {x = self.redblobs[i].x + self.xoffset, y = self.redblobs[i].y + self.yoffset, width = self.width, height = self.height}

	local tile = map:getneartilepos(self.redblobs[i].x, self.redblobs[i].y, self.width, self.height, currentmap)	
	for y = 1, #tile do
		for k = 1, #solidids do
			if tile[y].id == solidids[k] then
				local col = getcollision(self.redblobs[i].hitbox, tile[y], 3)
				if col then
					if col.hor then
						self.redblobs[i].x = self.redblobs[i].x + col.x 
						self.redblobs[i].velx = 0
					end
					if col.ver then
						self.redblobs[i].y = self.redblobs[i].y + col.y
						self.redblobs[i].vely = 0
					end
					if col.side == "right" then
						self.redblobs[i].dir = "left"
					end
					if col.side == "left" then
						self.redblobs[i].dir = "right" 
					end
					if col.side == "down" then
						if self.redblobs[i].onground == false then
							self.redblobs[i].velx = 0
						end
						self.redblobs[i].onground = true
						self.redblobs[i].state = "run"
					end
					self.redblobs[i].hitbox = {x = self.redblobs[i].x + self.xoffset, y = self.redblobs[i].y + self.yoffset, width = self.width, height = self.height}
				end
			end
		end
	end
end

