game = {}

leaf = {}

function game:init()
	
	gamecomplete = false
	gravity = 300
	friction = 200
	--camera:
	scrollfactor = 6
	scrollfactory = 2
	actx = 8
	acty = 3
		
	loadmap()

	map:init("res/tile.png")
	currentmap = copymap(map1)

	backlayer0 = love.graphics.newImage("res/layer0.png")
	backlayer1 = love.graphics.newImage("res/layer1.png")
	backlayer2 = love.graphics.newImage("res/layer2.png")
	

	enemy = {}

	local pos = map:gettilepos(currentmap, {17})
	
	player:init(pos[1].x, pos[1].y)	
	currentmap[pos[1].mapy][pos[1].mapx] = 0

	gem:init()
	gui:init()
	powerup:init()
	blob:init()
	redblob:init()
	blueblob:init()
	fly:init()
	bossone:init()
	bosstwo:init()
	bosstri:init()
	spike:init()

	wallid = 12

	--leaf:init()

	solidids = {1,2,wallid }
	solidtile = map:gettilepos(currentmap, solidids) -- needed for old enemies

	smokeimg = love.graphics.newImage("res/smoke.png")
	explosionimg = love.graphics.newImage("res/explosion.png")
	bloodimg = love.graphics.newImage("res/blood.png")
	collisionimg = love.graphics.newImage("res/col.png")
	particles = {}
	flashes = {}

	gunpickup = {}
	gunpickup.active = true
	gunpickup.hitbox = {}
	gunpickup.gun = player.gun["simple"]
	local pos = map:gettilepos(currentmap, {16})
	gunpickup.hitbox.x = pos[1].x
	gunpickup.hitbox.y = pos[1].y
	currentmap[pos[1].mapy][pos[1].mapx] = 0
	gunpickup.img = gunpickup.gun.view
	gunpickup.hitbox.width = gunpickup.img:getWidth() * 2
	gunpickup.hitbox.height = gunpickup.img:getHeight() * 2

	hearts = {}
	hearts.img = gui.hp.heart --7x6
	hearts.value = 3
	hearts.width = 7
	hearts.height = 6
	hearts.hitboxs = {}

	deadtimer = timer:new(5,false)
	finaltimer = timer:new(5,false)
end

function game:update(dt)
	gui:update(dt)
	player:update(dt)
	camera:update(player, scrollfactor,scrollfactory,actx, acty) 
	--temporal enemy activity , done:remember gems and powerups
	updateenemy(dt)
	leaf:update(dt)

	if gunpickup.active then
		if shortaabb(player.hitbox, gunpickup.hitbox) then
			gunpickup.gun.has = true
			gunpickup.hitbox = {}
			gunpickup.active = false
			player.currentgun = gunpickup.gun
			player.gun.own = player.gun.own + 1
			player.gun.num = player.gun.own
		end
	end

	for i = 1, #hearts.hitboxs do
		if shortaabb(player.hitbox, hearts.hitboxs[i]) then
			player.hp = player.hp + hearts.value
			if player.hp > player.maxhp then
				player.hp = player.maxhp
			end
			hearts.hitboxs[i] = nil
		end
	end
	ordertable(hearts.hitboxs)

	if deadtimer.tick then
		deadtimer.active = false
		state = menu
		camera.x = 0
		game:init()
	end

	if finaltimer.tick then
		finaltimer.active = false
		state = menu
		camera.x = 0
		game:init()
	end
end

function game:draw()
	love.graphics.push()

	love.graphics.translate(camera.x, camera.y)
		love.graphics.setColor(255,255,255)
		
		camera:loopback(backlayer0, 0.9)	
		camera:loopback(backlayer1, 0.4)	
		camera:loopback(backlayer2, 0)

		powerup:loop()
		gem:loop()
		blob:loop()
		redblob:loop()
		blueblob:loop()
		bossone:loop()
		bosstwo:loop()
		bosstri:loop()
		spike:loop()
		fly:loop()
		player:draw()
		leaf:draw()

		map:draw(currentmap, camera.x, camera.y)
		drawparticles()

		if gunpickup.active then
			love.graphics.draw(gunpickup.img, gunpickup.hitbox.x ,gunpickup.hitbox.y ,0,2,2)
		end

		for i = 1, #hearts.hitboxs do
			love.graphics.draw(hearts.img, hearts.hitboxs[i].x, hearts.hitboxs[i].y)
		end


	love.graphics.pop()
		gui:draw()

		if player.dead then
			local width = font.medium:getWidth("game over")
			love.graphics.setFont(font.medium)
			love.graphics.print("game over", wx/2 - width/2, wy/3)
		end

		if gamecomplete then
			local width = font.medium:getWidth("you win!")
			love.graphics.setFont(font.medium)
			love.graphics.print("you win!", wx/2 - width/2, wy/3)
		end

		if gamedebug then
			local tile = scrollfactor*tilesize
			local tiley = scrollfactory*tilesize
			local ax = actx * tilesize
			local ay = acty * tilesize
			local tab = map:getneartilepos(player.x, player.y,player.width,player.height, currentmap)

			love.graphics.setColor(0,0,255)
			for i = 1,#tab do
				love.graphics.rectangle("line", camera.x + tab[i].x, camera.y + tab[i].y, tilesize, tilesize)
			end
			love.graphics.setColor(255,255,255)
			love.graphics.polygon("line", tile, tiley, wx-tile,tiley, wx-tile,wy-tiley,tile,wy-tiley)
			love.graphics.polygon("line", ax, ay, wx-ax,ay, wx-ax,wy-ay,ax,wy-ay)
		end
	
end

function updateenemy(dt)
	local maxoffscreen = 3 * tilesize

	local boss = false
	for i = 1, #enemy do
		for k = 1, #enemy[i] do
			if enemy[i][k] ~= nil then

				if enemy[i][k].dead == false then
					enemy[i][k].active = camera:inscreen(enemy[i][k].hitbox.x ,enemy[i][k].hitbox.y, enemy[i][k].hitbox.width, enemy[i][k].hitbox.height, maxoffscreen)


					local bossrange = 20
					if enemy[i][k].type == "boss" then
						if getdist(player.x, player.y, enemy[i][k].x, enemy[i][k].y) < tilesize * bossrange then
							boss = enemy[i][k]
						end
					end



				else

					player.score = player.score + enemy[i][k].points			
					
					particles[#particles +1] = partsys:new(smokeimg,enemy[i][k].x,enemy[i][k].y,{0.4 ,0.8},{tilesize,2 * tilesize}, math.random(3,7))

					flashes[#flashes+1] = {x = enemy[i][k].x + enemy[i][k].hitbox.width/2, y = enemy[i][k].y + enemy[i][k].hitbox.height/2}

					if enemy[i][k].type == "boss" then
						gunpickup.active = true
						gunpickup.gun = enemy[i][k].gun
						gunpickup.hitbox.x = enemy[i][k].x
						gunpickup.hitbox.y = enemy[i][k].y
						gunpickup.img = gunpickup.gun.view
						gunpickup.hitbox.width = gunpickup.img:getWidth() * 2
						gunpickup.hitbox.height = gunpickup.img:getHeight() * 2

						if enemy[i][k].final then
							gamecomplete = true
							finaltimer.active = true
						end
					else
						local dropheart = false
						local rand = math.random(1,4)

						if rand == 3 then	
							dropheart = true
						end

						if dropheart then
							hearts.hitboxs[#hearts.hitboxs + 1] = {x = enemy[i][k].x + enemy[i][k].hitbox.width/2, y = enemy[i][k].y + enemy[i][k].hitbox.height/2, width = hearts.width, height = hearts.height}


						end

					end

					enemy[i][k] = nil
					ordertable(enemy[i])
					
				end
			end
		end
	end
	gui.boss.target = boss

end

function drawparticles()
	for i = 1, #flashes do
		if flashes[i] ~= nil then
			if flashes[i].first == nil then
				flashes[i].first = false
			end

			local done = false
			if flashes[i].first then
				love.graphics.setColor(0,0,50)
				done = true
			else
				love.graphics.setColor(255,255,255)
				flashes[i].first = true
			end

			love.graphics.circle("fill", flashes[i].x, flashes[i].y, tilesize * 1.5)
			love.graphics.setColor(255,255,255)	
	
			if done then
				flashes[i] = nil
				ordertable(flashes)
			end
		end

	end

	for i = 1, #particles do
		if particles[i] ~= nil then
			particles[i]:draw()
			if particles[i].done then
				particles[i] = nil
				ordertable(particles)
			end
		end
	end

end

function changemap(nextmap)
	player.x = 0
	player.y = 80
	player.velx = 0
	player.vely = 0
	player.onground = false

	camera.x = 0
	camera.y = 0
	_layer = nil
	
	currentmap = copymap(nextmap)
	
	enemy = {}
	particles = {}
	flashes = {}

	gem:init()
	changeling:init()
	gui:init()
	powerup:init()
	chrysalis:init()
	blob:init()
	redblob:init()
	fly:init()
	leaf:init()

	solidtile = map:gettilepos(currentmap, solidids)
end

function changetogame()
	camera.x = -player.x + 100
	state = game
	love.graphics.setLineWidth(gui.linewidth)


end

function leaf:init()
	self.active = true
	self.img = love.graphics.newImage("res/leaf.png")
	self.width = leaf.img:getWidth()
	self.height = leaf.img:getHeight()
	self.speed = 100
	self.obj = {}
	self.spawntime = timer:new(0.5, true)
	self.diedelay = 2
end

function leaf:update(dt)
	if self.active then
		if self.spawntime.tick then
			local t = {}
			local di = math.random(0,1)
			t.x = math.random(0, wx) - camera.x
			t.y = -camera.y
			t.velx = -10
			t.width = self.width
			t.height = self.height/1.5
			t.active = true
			t.time = 0
			if di == 0 then
				t.dir = "right"
			else
				t.dir = "left"
			end
			self.obj[#self.obj + 1] = t
		end
		for i = 1, #self.obj do
			if self.obj[i].active then
				if self.obj[i].dir == "right" then
						self.obj[i].velx = self.obj[i].velx - math.random(100,200) * dt
						if self.obj[i].velx < 0 then
							self.obj[i].dir = "left"
							self.obj[i].velx = - self.speed
						end
				end
				if self.obj[i].dir == "left" then
						self.obj[i].velx = self.obj[i].velx + math.random(100,200) * dt
						if self.obj[i].velx > 0 then
							self.obj[i].dir = "right"
							self.obj[i].velx = self.speed
						end
				end
				self.obj[i].y = self.obj[i].y + (self.speed*(2/3)) * dt
				self.obj[i].x = self.obj[i].x + self.obj[i].velx * dt

				for y = 1, #solidtile do
					if shortaabb(self.obj[i], solidtile[y]) then
						self.obj[i].active = false
					end
				end
			
				if self.obj[i].y > wy - camera.y then
						self.obj[i] = nil
				end
			else
				self.obj[i].time = self.obj[i].time + dt
				if self.obj[i].time > self.diedelay then
					self.obj[i] = nil
				end
			end		
		end
		ordertable(self.obj)
	end
end

function leaf:draw()
	if self.active then
		for i = 1, #self.obj do
			local scl = 1
			local offx = 0
			if self.obj[i].dir == "left" then
				scl = -1
				offx = self.width
			end
			love.graphics.draw(self.img, self.obj[i].x, self.obj[i].y, 0, scl, 1, offx)
		end
	end
end

function game:keypressed(k)

end
