gem = {}

function gem:init()
	self.id = 5
	self.width = 14
	self.height = 11
	self.state = "idle"
	self.active = {}
	self.ydist = 1
	self.speed = 10
	self.value = 1
	self.points = 100
	self.img = love.graphics.newImage("res/gem.png")
	self.gems = {}
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.gems[i] = {}
		self.gems[i].x = pos[i].x + 1
		self.gems[i].inity = pos[i].y
		self.gems[i].y = self.gems[i].inity
		self.gems[i].vely = 0
		self.gems[i].active = false
		self.gems[i].dead = false
		self.gems[i].up = true
		self.gems[i].anim = sprite:new(self.img, self.width, self.height, {{"idle",3}})
		currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	
end

function gem:loop()
	for i = 1, #self.gems do
		
		if self.gems[i].dead == false then
			self.gems[i].active = camera:inscreen(self.gems[i].x,self.gems[i].y,self.width,self.height,self.width)
		end

		if self.gems[i].active then
			local dt = love.timer.getDelta()
			self.gems[i].y = self.gems[i].y + self.gems[i].vely * dt 
			local hitbox = {x = self.gems[i].x, y = self.gems[i].y, width = self.width, height = self.height , state = self.state}
			if shortaabb(player,hitbox) then
				player.score = player.score + self.points
				player.gems = player.gems + self.value
				self.gems[i].active = false
				self.gems[i].dead = true
			end
			love.graphics.setColor(255,255,255)
			self.gems[i].anim:draw(hitbox, 0.2)
			if gamedebug then
				love.graphics.setColor(255,255,0)
				love.graphics.rectangle("line", self.gems[i].x, self.gems[i].y, self.width, self.height)
			end

			local maxy = self.gems[i].inity + self.ydist
			local miny = self.gems[i].inity - self.ydist

			if self.gems[i].up then
				local diff = (miny-self.gems[i].y)/-self.ydist
				self.gems[i].vely = self.gems[i].vely - self.speed * diff * dt
				if self.gems[i].y <= miny then
					self.gems[i].up = false
					self.gems[i].vely = -self.speed
				end


			else
				local diff = (maxy-self.gems[i].y)/self.ydist
				self.gems[i].vely = self.gems[i].vely + self.speed * diff * dt
				if self.gems[i].y >= maxy then
					self.gems[i].up = true
					self.gems[i].vely = self.speed
				end
			end
		end
	end
end

