
gui = {}
function gui:init()	
	self.linewidth = 1.5

	self.gem = {}
	self.gem.img = gem.img
	self.gem.quad = love.graphics.newQuad(0,0, gem.width, gem.height, self.gem.img:getWidth(), self.gem.img:getHeight())
	self.gem.x = 10
	self.gem.y = 10
	self.gem.scale = 0.6
	self.gem.txt = {}
	self.gem.txt.x = self.gem.x + (self.gem.img:getWidth()/3) * self.gem.scale
	self.gem.txt.y = self.gem.y 
	self.gem.txt.text = ":"..player.gems
	
	self.hp = {}
	self.hp.heart = love.graphics.newImage("res/heart.png") --7x6
	self.hp.scale = 1
	self.hp.x = 5
	self.hp.y = 5 + self.linewidth
	self.hp.printx = self.hp.x + (self.hp.heart:getWidth() * self.hp.scale) + self.linewidth
	self.hp.width = 50
	self.hp.height = self.hp.heart:getHeight() * self.hp.scale
	self.hp.current = self.hp.width
	self.hp.num = tostring(self.hp.max)
	self.hp.numspace = font.gui:getWidth("991")
	
	self.gun = {}
	self.gun.x = 5 + self.linewidth
	self.gun.y = 20
	self.gun.frame = player.currentgun.view
	self.gun.scale = 3
	self.gun.width = self.gun.frame:getWidth() * self.gun.scale
	self.gun.height = self.gun.frame:getHeight() * self.gun.scale
	self.gun.ammospace = font.gui:getWidth("0")

	self.boss = {}
	self.boss.target = false
	self.boss.x = 5 
	self.boss.y = wy - font.gui:getHeight("boss") - 3
	self.boss.width = wx - font.gui:getWidth("boss") - 4*self.linewidth - 10
	self.boss.height = font.gui:getHeight("boss") - 5
	self.boss.current = 0
	self.boss.numspace = font.gui:getWidth("boss") + 5
	 

end

function gui:update(dt)
	self.gem.txt.text = ":"..player.gems

	self.hp.current = (player.hp/player.maxhp) * self.hp.width
	self.hp.num = tostring(player.hp)

	self.gun.frame = player.currentgun.view

	if self.boss.target then
		self.boss.current = (self.boss.target.health/self.boss.target.maxhealth) * self.boss.width - self.linewidth
	end
end

function gui:draw()
	love.graphics.setFont(font.gui)
	--love.graphics.draw(self.gem.img, self.gem.quad, self.gem.x, self.gem.y, 0 , self.gem.scale, self.gem.scale)
	--love.graphics.print(self.gem.txt.text, self.gem.txt.x, self.gem.txt.y)



	--hp
	local rectx = self.hp.printx + self.hp.numspace
	love.graphics.draw(self.hp.heart, self.hp.x, self.hp.y,0,self.hp.scale,self.hp.scale)
	love.graphics.print(self.hp.num, self.hp.printx, self.hp.y - 4)
	love.graphics.rectangle("line", rectx-self.linewidth/2, self.hp.y- self.linewidth/2, self.hp.width+self.linewidth, self.hp.height+self.linewidth)

	love.graphics.setColor(155,0,0)
	love.graphics.rectangle("fill", rectx, self.hp.y, self.hp.width, self.hp.height)
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("fill", rectx, self.hp.y, self.hp.current, self.hp.height)
	love.graphics.setColor(255,255,255)

	--gun
	if player.currentgun ~= player.gun["init"] then
		local gun = player.currentgun
		love.graphics.rectangle("line", self.gun.x - self.linewidth/2, self.gun.y - self.linewidth/2, self.gun.width+self.linewidth, self.gun.height+self.linewidth)
		love.graphics.draw(self.gun.frame,self.gun.x, self.gun.y,0,self.gun.scale,self.gun.scale)
		if gun.ammo ~= nil then
			love.graphics.print(tostring(gun.ammo).."/"..tostring(gun.maxammo),self.gun.x + self.gun.width + self.gun.ammospace,self.gun.y)
		end
	end

	--boss
	if self.boss.target then
		love.graphics.print("boss",self.boss.x, self.boss.y)
		love.graphics.rectangle("line", self.boss.x + self.boss.numspace, self.boss.y + 3, self.boss.width, self.boss.height)
		love.graphics.setColor(155,0,0)
		love.graphics.rectangle("fill", self.boss.x + self.boss.numspace + self.linewidth/2, self.boss.y + 3 + self.linewidth/2, self.boss.width - self.linewidth, self.boss.height- self.linewidth)
		love.graphics.setColor(255,0,0)
		love.graphics.rectangle("fill", self.boss.x + self.boss.numspace + self.linewidth/2, self.boss.y + 3 + self.linewidth/2, self.boss.current, self.boss.height- self.linewidth)
		love.graphics.setColor(255,255,255)
	end

end
