-- SIMPLE CAMERA (1.0)
-- if "tilesize" exists, then it will be used as "dist" mesurement. 
-- don't know about action speed
local camera = {}
camera.x = 0
camera.y = 0
camera.set = true
camera.scroll = false
camera.isshake = false
function camera:update(obj, dist, disty, actx, acty)
	if self.set then
		local dx,dy
		local actionx, actiony
		if tilesize then
			dx = dist * tilesize
			dy = disty * tilesize or dx
			if actx then
				actionx = actx * tilesize
				if acty then
					actiony = acty * tilesize
				else
					actiony = actionx
				end
			end	
		else
			dx = dist
			dy = disty or dx
			actionx = actx or 0
			actiony = acty or actx or 0
		end
		if self.isshake then
			self.x = self.realcamx
			self.y = self.realcamy
		end
		self.scroll = false
		if actx then
			local dt = love.timer.getDelta()
			local speed = obj.maxxspeed
			if obj.x < -self.x + actionx then
				local diffx = ((-self.x + actionx) - obj.x)/(actionx - dx)
				self.x = self.x + (speed * diffx * dt)
 				self.scroll = true
				
			end
			if obj.x + obj.width + obj.widthdif > (-self.x + wx) - actionx then
				local diffx = ((obj.x + obj.width + obj.widthdif)-(-self.x + wx - actionx))/((wx - dx)-(wx - actionx))
				self.x = self.x - (speed * diffx * dt) 
				self.scroll = true
			end
	
			if obj.y < -self.y + actiony then
				local diffy = ((-self.y + actiony) - obj.y)/(actiony - dy)
				self.y = self.y + (speed * diffy * dt)
				self.scroll = true
 				
				
			end
			if obj.y + obj.height > (-self.y + wy) - actiony then
				local diffy = ((obj.y + obj.height)-(-self.y + wy - actiony))/((wy - dy)-(wy - actiony))
				self.y = self.y - (speed * diffy * dt)
				self.scroll = true
			end
		end
		-- x
		if obj.x < -(self.x) + dx then 
			self.x = -(obj.x - dx)
			self.scroll = true
		elseif obj.x + obj.width + obj.widthdif > (-self.x + wx) - dx then
			self.x = -((obj.x + obj.width + obj.widthdif + dx) - wx)
			self.scroll = true
		end
		--- y
		if obj.y < -(self.y) + dy then
			self.y = -(obj.y - dy)
			self.scroll = true
		elseif obj.y + obj.height > (-self.y + wy) - dy then
			self.y = -((obj.y + obj.height + dy) - wy)
			self.scroll = true
		end
	
		if self.isshake then
			local dt = love.timer.getDelta()
			self.time = self.time + dt
			local dif = (self.shaketime - self.time)/self.shaketime
			local shakex = ((math.random(-1,1))*self.mag*dif)
			local shakey = ((math.random(-1,1))*self.mag*dif)
			self.realcamx = self.x
			self.realcamy = self.y
	
			self.x = self.realcamx + shakex
			self.y = self.realcamy + shakey

			self.mag = self.mag
			if dif < 0 then
				self.mag = nil
				self.time = nil
				self.shaketime = nil
				self.realcamx = nil
				self.realcamy = nil
				self.isshake = false
			end
		end
	end
end

function camera:loopback(img,scrollparalex) -- mover background a la izquierda -- scrollparalex entre 0 y 1
	local cam = self
	if _layer == nil then
		_layer = {}
		_layer[1] = {}
		_layer[1].x = -cam.x
		_layer[1].oldcamx = -cam.x
		_layer[1].id = scrollparalex -- who is going to use the same paralex in different layers anyway
	end

	local registed = false
	
	for i = 1, #_layer do
		if scrollparalex == _layer[i].id then
			registed = true

			local dt = love.timer.getDelta()
			local diff = _layer[i].oldcamx - cam.x
			local imgwidth = img:getWidth()
			local dir

			if diff ~= 0 then
				if diff > 0 then
					dir = "right"
				else
					dir = "left"
				end
			end
		
			if dir then
				if dir == "right" then
					if -cam.x >= _layer[i].x + imgwidth then
						_layer[i].x = -cam.x
					end
				else
					if -cam.x <= _layer[i].x then
						_layer[i].x = -cam.x - imgwidth
					end
				end
			end
			_layer[i].x = _layer[i].x + diff * scrollparalex

			if scrollparalex == 1 then
				_layer[i].x = -self.x
			end

			love.graphics.draw(img, _layer[i].x, -cam.y)
			love.graphics.draw(img, _layer[i].x + imgwidth, -cam.y)

			_layer[i].oldcamx = cam.x
			
		end
		
	end

	if registed == false then
		local n = #_layer + 1
		_layer[n] = {}
		_layer[n].x = -cam.x
		_layer[n].oldcamx = -cam.x
		_layer[n].id = scrollparalex
		self:loopback(img, scrollparalex)
	end
end

function camera:inscreen(x,y,width,height, maxoffscreenx, maxoffscreeny)
	local maxoffscreenx = maxoffscreenx or 0
	local maxoffscreeny = maxoffscreeny or maxoffscreenx
	if x > -self.x - maxoffscreenx and x + width < wx - self.x + maxoffscreenx then
		if y > -self.y - maxoffscreeny and y + height < wy - self.y + maxoffscreeny then
			inscreen = true
		else
			inscreen = false
		end
	else
		inscreen = false
	end
	return inscreen
end

function camera:shake(magnitud, time)
	self.isshake = true
	self.mag = magnitud
	self.shaketime = time
	self.time = 0
	if self.realcamx == nil then
		self.realcamx = self.x
		self.realcamy = self.y
	end
end

return camera

