-- REANIMATION (1.0) -- PLAYERSTATE BASED, ONLY LOOPS AND STATIC, ONLY LEFT TO RIGHT SPRITES LOOKING TO THE RIGHT
local sprite = {}

function sprite:new(spriteloc, width, height, t, xoffset, yoffset) -- t = {{"stand", 4}, {"jump", 3}, {"run", 2}} -- {"state", spritenum}
	local table = {}
	table.yoffset = yoffset or 0
	table.xoffset = xoffset or 0
	table.__index = sprite
	if type(spriteloc) == "string" then
		table.img = love.graphics.newImage(spriteloc)
	else
		table.img = spriteloc
	end
	table.sprites = {}
	table.width = width
	table.height = height

	table.states = {}
	--creat quads
	local n = 0
	for i = 1,#t do
		local var1 = t[i]	
		local var2 = var1[1]
		local var3 = var1[2]

		table.states[#table.states + 1] = var2 
		table.sprites[var2] = {}

		for e = 1, var3 do 
			table.sprites[var2][e] = love.graphics.newQuad(n * width, 0, width, height, table.img:getWidth(), table.img:getHeight())	
			n = n + 1	
		end
	end

	table.spritetimer = 0
	table.framecount = 1
	table.frame = table.sprites[table.states[1]][1]
	setmetatable(table,table)
	return table
end

function sprite:draw(obj, delay)
	-- set configuration
	local tweak = xtweak or 0
	local delay = delay or 0.2
	local dt = love.timer.getDelta()
	local scl, xset, yset
	if obj.dir == "right" then 
		scl = 1
		xset = self.xoffset
		
	elseif obj.dir == "left" then
		scl = -1 
		xset = self.width + self.xoffset
	end
	yset = self.yoffset

	-- animate sprite
	self.spritetimer = self.spritetimer + dt
	local var
	local sav = self.frame
	for i = 1, #self.states do
		if self.states[i] == obj.state then
			var = self.sprites[self.states[i]]

			if self.spritetimer > delay then
				self.spritetimer = 0
				self.framecount = self.framecount + 1
				if self.framecount > #var then
					self.framecount = 1 
				end
			end
			self.frame = var[self.framecount]
		end
	end
	if self.frame == nil then	
		self.frame = sav
	end
	love.graphics.draw(self.img, self.frame, obj.x, obj.y, 0, scl, 1, xset, yset)
end

return sprite

