-- SIMPLE TIMER (0.9)
local timer = {}

function timer:new(delay, active) -- delay in seconds
	if _timerlist == nil then
		_timerlist = {}
	end
	local table = {}
	table.id = self
	table.time = 0
	table.delay = delay
	table.tick = false
	table.active = active and true
	_timerlist[#_timerlist + 1] = table
	return _timerlist[#_timerlist]
end

function timer:kill()
	for i,v in pairs(_timerlist) do
		if v.id == self then
			_timerlist[i] = nil
			return nil
		end
	end	
end

function timer:update(dt)
	if _timerlist then
		for i,v in pairs(_timerlist) do
			v.tick = false
			if v.active then
				v.time = v.time + dt
				if v.delay then
					if v.time >= v.delay then
						v.time = 0
						v.tick = true
					end
				end
			end
		end
	end
end

return timer

