menu = {}

function menu:init()
	
	menu.state = "main"
	linewidth = 5
	backspeed = 100
	arrow = {}
	arrow.img = love.graphics.newImage("res/arrow.gif")
	arrow.n = 1
	arrow.x = 0
	arrow.y = 0
	arrow.width = arrow.img:getWidth()
	love.graphics.setLineWidth(linewidth)
	font = {}
	font.title = love.graphics.newFont("res/font2.ttf", 64)
	font.medium = love.graphics.newFont("res/font.ttf", 36)
	font.small = love.graphics.newFont("res/font.ttf", 12)
	font.gui = love.graphics.newFont("res/font.ttf", 15)
	love.graphics.setFont(font.small)
	
	txt = {}
	txt.title = "Shooter"
	love.window.setTitle(txt.title)

	txt.main = {}
	txt.main.font = font.medium

	txt.main[1] = {}
	txt.main[1].txt = "play"
	txt.main[1].y = wy*(4/8)

	txt.main[2] = {}
	txt.main[2].txt = "exit"
	txt.main[2].y = wy*(5/8)
	

end

function menu:update(dt)
	camera.x = camera.x - backspeed * dt

	if arrow.n == 1 and key.jumpdown then
		changetogame()
	end
		
	if arrow.n == 2 and key.jumpdown then
		love.event.quit()
	end
	

end

function menu:draw()
	love.graphics.push()
	love.graphics.translate(camera.x, camera.y)
		love.graphics.setColor(255,255,255)
		camera:loopback(backlayer0, 0.9)	
		camera:loopback(backlayer1, 0.4)	
		camera:loopback(backlayer2, 0)
	love.graphics.pop()

	love.graphics.rectangle("line", 10,10,wx-10-linewidth*2,wy-10-linewidth*2)

	love.graphics.setFont(font.title)
	love.graphics.print(txt.title, (wx/2)-(font.title:getWidth(txt.title))/2, wy/7)
	love.graphics.setFont(txt[menu.state].font)

	for i = 1, #txt[menu.state] do
		love.graphics.print(txt[menu.state][i].txt, (wx/2)-(txt[menu.state].font:getWidth(txt[menu.state][i].txt))/2, txt[menu.state][i].y)
		if i == arrow.n then
			arrow.x = (wx/2)-(txt[menu.state].font:getWidth(txt[menu.state][i].txt))/2 - arrow.width - 3
			arrow.y = txt[menu.state][i].y + txt[menu.state].font:getHeight(txt[menu.state][i].txt)/4
		end
	
	end
	love.graphics.draw(arrow.img, arrow.x, arrow.y)


	
	love.graphics.setFont(font.gui)
	love.graphics.print("controls: arrows, x,z \n\"a\",\"s\" to change weapon", 90,190)
	
end

function menu:keypressed(k)
	if k == key.up then
		arrow.n = math.min(arrow.n + 1, #txt[menu.state]-1)
	end
	if k == key.down then
		arrow.n = math.max(arrow.n - 1, #txt[menu.state])
	end
	
end
