
spike = {}
spike.__index = spike
-- non mercy action
function spike:init()
	self.spikes = {}
	self.id = 11
	self.widthdif = 3
	self.heightdif = 4
	self.activerange = tilesize*1.5
	self.jumpspeed = -100
	self.damage = 5

	self.width = tilesize - self.widthdif
	self.height = tilesize - self.heightdif
	self.xoffset = self.widthdif/2
	self.yoffset = self.heightdif
	
	local pos = map:gettilepos(currentmap, {self.id})
	for i = 1, #pos do
		self.spikes[i] = {}
		self.spikes[i].x = pos[i].x
		self.spikes[i].y = pos[i].y	
		self.spikes[i].hitbox = {x = self.spikes[i].x + self.xoffset, y = self.spikes[i].y + self.yoffset, width = self.width, height = self.height}
		self.spikes[i].active = false
		--currentmap[pos[i].mapy][pos[i].mapx] = 0
	end
	setmetatable(spike, spike)
end

function spike:loop()
	for i = 1, #self.spikes do
		self.spikes[i].active = getdist(player.x,player.y,self.spikes[i].x,self.spikes[i].y) < self.activerange
		if self.spikes[i].active then
			local hit
			hit = self:collision(i)
			if hit then
				break
			end
			if gamedebug == true then
				love.graphics.setColor(255, 0, 0)
				love.graphics.rectangle("line", self.spikes[i].hitbox.x, self.spikes[i].hitbox.y, self.spikes[i].hitbox.width, self.spikes[i].hitbox.height)
				love.graphics.setColor(255,255,255)
			end
		end
	end
end

function spike:collision(i)
	local col = getcollision(self.spikes[i].hitbox, player.hitbox, 3)
	local hit = false
	if col then
		if col.hor then
			player.x = player.x - col.x
			player.velx = 0

		end
		if col.ver then
			if col.side == "up" then
				hit = true
				player.onground = false
				player.vely = self.jumpspeed
				player.hp = player.hp - self.damage
				player.mercy = true
				player.mercytimer.active = true
				particles[#particles +1] = partsys:new(bloodimg, player.x+(tilesize/4), player.y+(tilesize/4), {0.5,0.8}, {tilesize,1.2 * tilesize}, math.random(6,9))
			end
		end
	end
	return hit
end

